/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		HighScore.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Christian Roesch
//
// Erstelldatum:	12.09.2001
// letzte nderung:	21.09.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Die HighScore Klasse kann eine beliebige Anzahl von HighScore-Listen
//			verwalten. So ist es mglich mehrere HighScores in einer Datei zu
//			speichern.
 /////////////////////////////////////////////////////////////////////////////////////


#ifndef _HighScore_H
#define _HighScore_H

// includes
#include <fstream.h>
#include <string.h>

#include "Xgamesdk\XLogging.h"

// Konstanten
const int iHighScoreEntries=5;
const int iHighScoreNameLength=10;

// Klassen-Deklaration
class	HighScoreList
{
	friend class HighScore;

private:
	char	pcNames[iHighScoreEntries*(iHighScoreNameLength+1)];
	int		iPoints[iHighScoreEntries];
};

class	HighScore
{
public:
		HighScore(int iNrOfLists);
		~HighScore(void);

void	resetData(void);

bool	load(char* pcFileName);
bool	save(char* pcFileName);

int		getEntry(int iList,int iEntry,char* pcDest);
bool	setEntry(int iList,char* pcSrc,int iPoints);
int		getMinimumPoints(int iList);
int		getNameLength(void);

protected:

private:
	HighScoreList*		m_phslData;	//dynamisches Feld von Highscorelisten
	int					m_iNrOfLists;

};

#endif // _HighScore_H

class	HighScore;

/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		HighScore.h
/////////////////////////////////////////////////////////////////////////////////////
