/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		PPGame.cpp
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Christian Roesch
//
// Erstelldatum:	07.08.2001
// letzte nderung:	23.11.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Die Klasse frs Ingame
/////////////////////////////////////////////////////////////////////////////////////

//includes
#include "PPGame.h"

// Methoden-Definitionen

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPGame::initialize
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Grafiken Laden, alles initialisieren
/////////////////////////////////////////////////////////////////////////////////////
HRESULT PPGame::initialize(XDisplay* pxdisplayDest)
{
	HRESULT hres;

	XLogging::log(" --- Game ---\n");

	m_ppPlayer[0]=NULL;
	m_ppPlayer[1]=NULL;
	m_ppPlayer[2]=NULL;	

	hres=m_xsurfField.initialize(pxdisplayDest,768,768);

	hres=m_xsBlack.initialize(pxdisplayDest,"gfx\\black.bmp");

	hres=m_xsBackLeft.initialize(pxdisplayDest,"gfx\\ingameleft.bmp");

	hres=m_xsBackRight.initialize(pxdisplayDest,"gfx\\ingameright.bmp");

	hres=m_xsurfAppleCount.initialize(pxdisplayDest,"gfx\\apcount.bmp");

	//Apfelzhler malen?
	if (g_configData.m_gmActual==SinglePlay)
	{
		m_xsurfAppleCount.blit(&m_xsBackRight,79,280);
	}	

	hres=m_xsTileSet.initialize(pxdisplayDest,"gfx\\tileset.spr");
	m_xsTileSet.m_bVisible=true;

	hres=m_xsParticles.initialize(pxdisplayDest,"gfx\\particles.spr");
	m_xsParticles.m_bVisible=true;

	hres=m_xsMenu.initialize(pxdisplayDest,"gfx\\igmenu.spr");
	m_xsMenu.m_bVisible=true;
	hres=m_xsMenuHead.initialize(pxdisplayDest,"gfx\\igmenuhead.spr");
	m_xsMenuHead.m_bVisible=true;

	hres=m_xfChars.initialize(pxdisplayDest,"gfx\\charset.fnt");


	//alle Effekte, die fr Stereoeffekte benutzt werden, mssen in 2D geladen werden
	m_pfsEat=g_xfmodHelper.loadSample(	"audio\\Game_Eat.mp3",
										FSOUND_FREE,
										FSOUND_LOOP_OFF | FSOUND_16BITS | FSOUND_2D );

	m_pfsTurn=g_xfmodHelper.loadSample(	"audio\\Game_Turn.mp3",
										FSOUND_FREE,
										FSOUND_LOOP_OFF | FSOUND_16BITS | FSOUND_2D );

	m_pfsTime1=g_xfmodHelper.loadSample("audio\\Game_Time1.mp3",
										FSOUND_FREE,
										FSOUND_LOOP_OFF | FSOUND_16BITS | FSOUND_HW3D );

	m_pfsTime2=g_xfmodHelper.loadSample("audio\\Game_Time2.mp3",
										FSOUND_FREE,
										FSOUND_LOOP_OFF | FSOUND_16BITS | FSOUND_HW3D );

	m_pfsOpen=g_xfmodHelper.loadSample(	"audio\\Game_Opening.mp3",
										FSOUND_FREE,
										FSOUND_LOOP_OFF | FSOUND_16BITS | FSOUND_HW3D );

	m_pfsMenu=g_xfmodHelper.loadSample(	"audio\\Game_Menu.mp3",
										FSOUND_FREE,
										FSOUND_LOOP_OFF | FSOUND_16BITS | FSOUND_HW3D );

	m_pfsDead=g_xfmodHelper.loadSample(	"audio\\Game_End1.mp3",
										FSOUND_FREE,
										FSOUND_LOOP_OFF | FSOUND_16BITS | FSOUND_HW3D );

	m_pfsWon=g_xfmodHelper.loadSample(	"audio\\Game_End2.mp3",
										FSOUND_FREE,
										FSOUND_LOOP_OFF | FSOUND_16BITS | FSOUND_HW3D );

	m_pfsStar=g_xfmodHelper.loadSample(	"audio\\Game_Star.mp3",
										FSOUND_FREE,
										FSOUND_LOOP_OFF | FSOUND_16BITS | FSOUND_2D );

	m_pfsRainbow=g_xfmodHelper.loadSample("audio\\Game_Rainbow.mp3",
										FSOUND_FREE,
										FSOUND_LOOP_OFF | FSOUND_16BITS | FSOUND_2D );

	m_pfsRedGotFlag=g_xfmodHelper.loadSample("audio\\Game_Red1.mp3",
										FSOUND_FREE,
										FSOUND_LOOP_OFF | FSOUND_16BITS | FSOUND_HW3D );

	m_pfsRedScores=g_xfmodHelper.loadSample("audio\\Game_Red2.mp3",
										FSOUND_FREE,
										FSOUND_LOOP_OFF | FSOUND_16BITS | FSOUND_HW3D );

	m_pfsBlueGotFlag=g_xfmodHelper.loadSample("audio\\Game_Blue1.mp3",
										FSOUND_FREE,
										FSOUND_LOOP_OFF | FSOUND_16BITS | FSOUND_HW3D );

	m_pfsBlueScores=g_xfmodHelper.loadSample("audio\\Game_Blue2.mp3",
										FSOUND_FREE,
										FSOUND_LOOP_OFF | FSOUND_16BITS | FSOUND_HW3D );


#ifdef FrameCount
	// FrameCounter initialisieren
	m_xfcFrameCounter.setFont(&m_xfChars);
	m_xfcFrameCounter.setText("fps $f4");
	m_xfcFrameCounter.m_lX	= 0;
	m_xfcFrameCounter.m_lY	= 0;
#endif

	m_pfmMuzak[0]=g_xfmodHelper.loadModule("audio\\ingame1.it");
	m_pfmMuzak[1]=g_xfmodHelper.loadModule("audio\\ingame2.it");
	m_iNumberOfMuzaks=2;
	m_iActualMuzak=0;
	m_iMusicTime=0;
	g_xfmodHelper.playModule(m_pfmMuzak[m_iActualMuzak],6,64);
	
	//Namen initialisieren
	m_pcPlayerName[0]=0;

	prepareGame();

	return hres;
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPGame::unitialize
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Grafiken kicken
/////////////////////////////////////////////////////////////////////////////////////
HRESULT PPGame::uninitialize(void)
{
	HRESULT hres;
	int iTmp;


	//Musik entladen
	for (iTmp=0;iTmp<m_iNumberOfMuzaks;iTmp++)
	{
		FMUSIC_StopSong(m_pfmMuzak[iTmp]);
		FMUSIC_FreeSong(m_pfmMuzak[iTmp]);
	}
	
	endGame();


	FSOUND_StopSound(FSOUND_ALL);

	FSOUND_Sample_Free(m_pfsTurn);
	FSOUND_Sample_Free(m_pfsEat);
	FSOUND_Sample_Free(m_pfsTime1);
	FSOUND_Sample_Free(m_pfsTime2);
	FSOUND_Sample_Free(m_pfsOpen);
	FSOUND_Sample_Free(m_pfsMenu);
	FSOUND_Sample_Free(m_pfsDead);
	FSOUND_Sample_Free(m_pfsWon);

	
	hres=m_xsurfField.uninitialize();

	hres=m_xsBlack.uninitialize();

	hres=m_xsBackLeft.uninitialize();

	hres=m_xsBackRight.uninitialize();

	hres=m_xsurfAppleCount.uninitialize();

	hres=m_xsTileSet.uninitialize();

	hres=m_xsParticles.uninitialize();

	hres=m_xsMenu.uninitialize();

	hres=m_xsMenuHead.uninitialize();

	hres=m_xfChars.uninitialize();

#ifdef FrameCount	
	m_xfcFrameCounter.uninitialize();
#endif
	
	return hres;
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPGame::recoverFromFocusLost
/////////////////////////////////////////////////////////////////////////////////////
// Info:	holt Surface zurck
/////////////////////////////////////////////////////////////////////////////////////
HRESULT PPGame::recoverFromFocusLost(void)
{
	HRESULT hres;

	hres=m_xsurfField.restore();

	hres=m_xsBlack.restore();

	hres=m_xsBackLeft.restore();

	hres=m_xsBackRight.restore();

	hres=m_xsurfAppleCount.restore();

	//Apfelzhler malen?
	if (g_configData.m_gmActual==SinglePlay)
	{
		m_xsurfAppleCount.blit(&m_xsBackRight,79,280);
	}	

	hres=m_xsTileSet.restore();

	hres=m_xsParticles.restore();

	hres=m_xsMenu.restore();

	hres=m_xsMenuHead.restore();


	hres=m_xfChars.restore();

	return hres;
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPGame::run
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Eigentlicher Ablauf im Game
/////////////////////////////////////////////////////////////////////////////////////
State PPGame::run(int iTime, XDisplay* pxdisplayDest)
{
	int iCount;

	m_stateNext=Game;

	m_pxdisplayActual=pxdisplayDest;
	m_iTimePassed+=iTime;

	switch(m_iGameStatus)
	{
	case 0://PreGame
		if (m_iTimePassed<1000)	//nach 1000ms GameStatus wechseln!
		{
			renderPreGame();
			break;
		}
		m_iGameStatus=1;
		m_iLastTick=m_iTimePassed;
		break;
	case 1://Game
		//Tasten abfragen
		g_xiInput.getKeyboardData();
		for(iCount=0;iCount<g_configData.m_iNrOfActivePlayers;iCount++)
			m_ppPlayer[iCount]->checkInput();
		
		// Wenn genug Zeit vorbei ist, Spiel ablaufen lassen
		if (m_iTimePassed-m_iLastTick>g_configData.m_iGameSpeed)
		{
			runGame();
			m_iLastTick+=g_configData.m_iGameSpeed;
		}
		
		//Spiel darstellen
		renderInGame(iTime);
		break;
	case 2:
		runMenu();
		renderInGame(iTime);
		renderInGameMenu();
		break;
	case 3:
		runGameOver();
		renderInGame(iTime);
		renderGameOver();
		break;
	default:
		checkKeys_DEF();
		renderInGame(iTime);
		showScreen_DEF();
		break;
	}

	//Musik-Handler
	if (g_configData.m_iMusicVolume>0)//berhaupt an?
	{
		if (FMUSIC_GetOrder(m_pfmMuzak[m_iActualMuzak])+1==
			FMUSIC_GetNumOrders(m_pfmMuzak[m_iActualMuzak])
			&& m_iTimePassed-m_iMusicTime>500)
		{
			FMUSIC_SetOrder(m_pfmMuzak[m_iActualMuzak],0);
			FMUSIC_StopSong(m_pfmMuzak[m_iActualMuzak]);

			m_iMusicTime=m_iTimePassed;

			m_iActualMuzak++;
			if (m_iActualMuzak==m_iNumberOfMuzaks)
				m_iActualMuzak=0;

			g_xfmodHelper.playModule(m_pfmMuzak[m_iActualMuzak],6,64);
		}
	}

	if (m_iMusicTime>m_iTimePassed)
	{
		m_iMusicTime=m_iTimePassed;
	}


	
#ifdef FrameCount
	m_xfcFrameCounter.blit(pxdisplayDest);
#endif
	
	return m_stateNext;
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPGame::renderInGame
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Bildschirmdarstellung im Spiel
/////////////////////////////////////////////////////////////////////////////////////
void PPGame::renderInGame(int iTime)
{
	char	pcTmp[256];
	int		iCount;

	//renderGameField
	m_Field.render(&m_xsurfField,&m_xsTileSet,0,0,16,false);
	m_xsurfField.blit(m_pxdisplayActual,80,0);
	
	if (g_configData.m_bParticles)
	{
		m_Field.renderParticles(m_pxdisplayActual,&m_xsParticles,iTime,80,0,16);
	}

	m_xsBackLeft.blit(m_pxdisplayActual,0,0);

	m_xsBackRight.blit(m_pxdisplayActual,848,0);
	
	//Apfelzhler malen?
	if (g_configData.m_gmActual==SinglePlay)
	{
		sprintf(pcTmp,"%02d",16-m_iFoodCount);
		m_xfChars.textOut(m_pxdisplayActual,975,286,pcTmp);
	}
	
	for (iCount=0;iCount<3;iCount++)
	{
		if (m_ppPlayer[iCount]==NULL)
		{
			m_xfChars.textOut(m_pxdisplayActual,948,264+120*iCount,"------");
		}
		else
		{
			sprintf(pcTmp,"%06d",m_ppPlayer[iCount]->addPoints(0));
			m_xfChars.textOut(m_pxdisplayActual,948,264+120*iCount,pcTmp);
		}
	}

	//Flagge an die Startpltze malen?
	if (g_configData.m_gmActual==CaptureTheFlag)
	{
		if (m_iFoodCount==0 || m_iFoodCount==1)
		{
			m_xsTileSet.m_lX=m_Field.getStartX(m_iFoodCount)*16+80;
			m_xsTileSet.m_lY=m_Field.getStartY(m_iFoodCount)*16;
			m_xsTileSet.m_lFrame=g_TileSetData.m_iFlag;
			m_xsTileSet.blit(m_pxdisplayActual);
		}
	}
	
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPGame::renderPreGame
/////////////////////////////////////////////////////////////////////////////////////
// Info:	realisiert der Vorhangeffekt am Anfang
/////////////////////////////////////////////////////////////////////////////////////
void PPGame::renderPreGame()
{
	int iAway;

	iAway=1000-m_iTimePassed;
	iAway=(iAway*iAway)/4000;

	m_xsBackLeft.blit(m_pxdisplayActual,-iAway,0);

	clearMin(80-iAway,848+iAway);

	m_xsBackRight.blit(m_pxdisplayActual,848+iAway,0);
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPGame::renderInGameMenu
/////////////////////////////////////////////////////////////////////////////////////
// Info:	zeigt das InGameMenu an
/////////////////////////////////////////////////////////////////////////////////////
void PPGame::renderInGameMenu()
{

	m_xsMenuHead.m_lX=384;
	m_xsMenuHead.m_lY=334;
	m_xsMenuHead.m_lFrame=0;
	m_xsMenuHead.blit(m_pxdisplayActual);
	
	m_xsMenu.m_lX=384;
	m_xsMenu.m_lY=354;
	m_xsMenu.m_lFrame=0;
	m_xsMenu.blit(m_pxdisplayActual);
	
	m_xfChars.textOut(m_pxdisplayActual,495,368,"resume");
	m_xfChars.textOut(m_pxdisplayActual,495,388,"restart");
	m_xfChars.textOut(m_pxdisplayActual,495,408,"exit");

	if (m_iTimePassed%500>200)
	{
		m_xfChars.textOut(m_pxdisplayActual,460,368+20*m_iMenuStatus,">>");
	}
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPGame::renderGameOver
/////////////////////////////////////////////////////////////////////////////////////
// Info:	zeigt das GameOver Menu an
/////////////////////////////////////////////////////////////////////////////////////
void PPGame::renderGameOver()
{

	m_xsMenuHead.m_lX=384;
	m_xsMenuHead.m_lY=334;
	m_xsMenuHead.m_lFrame=1;
	m_xsMenuHead.blit(m_pxdisplayActual);
	
	m_xsMenu.m_lX=384;
	m_xsMenu.m_lY=354;
	m_xsMenu.m_lFrame=0;
	m_xsMenu.blit(m_pxdisplayActual);
	
	m_xfChars.textOut(m_pxdisplayActual,495,378,"restart");
	m_xfChars.textOut(m_pxdisplayActual,495,398,"exit");

	if (m_iTimePassed%500>200)
	{
		m_xfChars.textOut(m_pxdisplayActual,460,378+20*m_iMenuStatus,">>");
	}
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPGame::clearMin
/////////////////////////////////////////////////////////////////////////////////////
// Info:	fllt den Bildschirm mit dem schwarzen Tile in der angegeben Breite
//			und der ganzen Hhe
//			der gelschte Bereich kann rechts grsser sein!!!
/////////////////////////////////////////////////////////////////////////////////////
void PPGame::clearMin(int iStartX, int iEndX)
{
	int iCountX;
	int iCountY;

	for(iCountX=iStartX;iCountX<iEndX;iCountX+=64)
		for(iCountY=0;iCountY<768;iCountY+=64)
		{
			m_xsBlack.blit(m_pxdisplayActual,iCountX,iCountY);
		}
	
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPGame::prepareGame
/////////////////////////////////////////////////////////////////////////////////////
// Info:	bereitet das Spiel vor (Level laden, Spieler erstellen...)
/////////////////////////////////////////////////////////////////////////////////////
void PPGame::prepareGame()
{
	int iCount;
	

	//Stati zurcksetzen
	m_iGameStatus=0;
	m_iMenuStatus=0;

	//Level laden
	g_configData.loadLevel(&m_Field);
	
	//vorerst noch der Testlevel ohne Rand!
	//m_Field.load("level\\test.lvl");

	//Spieler erstellen
	for(iCount=0;iCount<g_configData.m_iNrOfActivePlayers;iCount++)
	{
		m_ppPlayer[iCount]=new Player(	iCount, 
										m_Field.getStartX(iCount), 
										m_Field.getStartY(iCount), 
										m_Field.getStartDirection(iCount));
	}
	
	//Feld initialisieren
	m_Field.render(&m_xsurfField,&m_xsTileSet,0,0,16);

	//spezielle Initialisiereungen je nach Spielmodus
	switch(g_configData.m_gmActual)
	{
	case SinglePlay:
		m_iFoodCount=0;
		m_bMoreFood=true;
		break;
	case DeathMatch:
		m_iFoodCount=0;
		m_bMoreFood=true;
		break;
	case Challenge:
		m_iFoodCount=0;
		m_bMoreFood=true;
		break;
	case CaptureTheFlag:
		m_iFoodCount=-1;
		m_bMoreFood=true;
		break;
	case EatEmAll:
		m_iFoodCount=-1;
		m_bMoreFood=true;
		for(iCount=0;iCount<g_configData.m_iNrOfActivePlayers;iCount++)
		{
			m_ppPlayer[iCount]->addPoints(300);
		}
		break;
	}

	//opening Sound spielen
	g_xfmodHelper.playSample(m_pfsOpen);

	//Zeit zurcksetzen
	m_iTimePassed=0;
	m_iLastTick=m_iTimePassed;
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPGame::runGame
/////////////////////////////////////////////////////////////////////////////////////
// Info:	lsst das Spiel ablaufen
/////////////////////////////////////////////////////////////////////////////////////
void PPGame::runGame()
{
	int		iCount;	
	int		iTile;
	int		iTmpX,iTmpY;
	int		iSoundLocation;

	int		iAliveCount=0;

	bool	bTmp;

	//spezielle Ablufe je nach Spielmodus
	switch(g_configData.m_gmActual)
	{
/////////////////////////////////////////////////////////////////////////////////////
	//Spielablauf SinglePlay
/////////////////////////////////////////////////////////////////////////////////////
	case SinglePlay:
		//wenn lebendig dann auch bewegen
		if (m_ppPlayer[0]->m_pSnake->alive())
		{
			//noch lebendig!
			iAliveCount++;

			//Bewegen
			iTile=m_ppPlayer[0]->m_pSnake->move(&m_Field);

			//Sound fr Drehbewegung?
			iSoundLocation=m_ppPlayer[0]->m_pSnake->getSoundFX();
			if (iSoundLocation>=1024)
			{
				iSoundLocation-=1024;
				g_xfmodHelper.playSample(m_pfsTurn,iSoundLocation*255/iFieldSizeX);
			}

			//Sound fr FoodTimer?
			if (m_iFoodSound*1000<m_iTimePassed-m_iFoodTime)
			{
				m_iFoodSound++;
				if (m_iFoodSound>=4 && m_iFoodSound<=8)
					g_xfmodHelper.playSample(m_pfsTime1);
				if (m_iFoodSound==9)
					g_xfmodHelper.playSample(m_pfsTime2);
			}

			//was Essbares gefunden?
			if (iTile>=g_TileSetData.m_iFirstEatable
				&& iTile<=g_TileSetData.m_iLastFree)
			{
				//Schlange verlngern
				m_ppPlayer[0]->m_pSnake->add(m_iFoodCount*4);

				//Sound fr Fressen spielen 
				g_xfmodHelper.playSample(m_pfsEat,iSoundLocation*255/iFieldSizeX);
				
				//ZusatzPunkte fr Zeit berechnen
				m_iFoodTime=m_iFoodTime-m_iTimePassed+8000;
				if (m_iFoodTime>5000)
					m_iFoodTime=5000;
				if (m_iFoodTime<0)
					m_iFoodTime=0;
				//Partikel...
				m_ppPlayer[0]->m_pSnake->emit(&m_Field,1,m_iFoodTime/250+10);
				m_iFoodTime=(m_iFoodTime*m_iFoodCount)/5000;
				
				
				//Punkte verteilen
				m_ppPlayer[0]->addPoints(3*(m_iFoodCount+m_iFoodTime));

				//will neues haben!
				m_bMoreFood=true;
				m_iFoodSound=99;

				//Checken ob letztes gefressen!
				if (m_iFoodCount==15)
				{
					//Partikel...
					m_ppPlayer[0]->m_pSnake->emit(&m_Field,1,30);

					//Sound spielen
					g_xfmodHelper.playSample(m_pfsWon);
					
					//kein neues Futter
					m_bMoreFood=false;

					//GameStatus schalten
					m_iGameStatus=10;

					//nur fr die Anzeige
					m_iFoodCount++;
				}
				
			}
			
			//Kollision = TOD
			if (iTile>=g_TileSetData.m_iLastFree)
			{
				//Partikel...
				m_ppPlayer[0]->m_pSnake->emit(&m_Field,5,30,true);

				m_ppPlayer[0]->m_pSnake->kill(&m_Field,iTile);
				g_xfmodHelper.playSample(m_pfsDead);
			}
		
		}
		//wenn ntig neues Futter machen
		if (m_bMoreFood)
		{
			//Feld suchen, am Rand zwei frei lassen
			iTmpX=2+rand()%(iFieldSizeX-4);
			iTmpY=2+rand()%(iFieldSizeY-4);
			
			//wenn total leer setzen, sonst Pech gehabt
			if (m_Field.isTotalEmpty(iTmpX,iTmpY))
			{
				m_Field.setTile(iTmpX,iTmpY,32 /* auch noch verzufallen?*/);
				m_bMoreFood=false;
				m_iFoodCount++;
				m_iFoodTime=m_iTimePassed;
				m_iFoodSound=1;
			}
		}

		//wenn Player tot ist, Spiel beenden
		if (iAliveCount==0)
		{
			// ins Menu gehen...
			m_iMenuStatus=0;
			m_iGameStatus=3;

			if (g_configData.m_bWrapAround)
			{
				iCount=1;
			}
			else
			{
				iCount=0;
			}

			if (m_ppPlayer[0]->addPoints(0) > g_hsData.getMinimumPoints(iCount))
			{
				m_iGameStatus=100+iCount;
			}

		}
		
		break;
/////////////////////////////////////////////////////////////////////////////////////
	//Spielablauf DeathMatch
/////////////////////////////////////////////////////////////////////////////////////
	case DeathMatch:
		for(iCount=0;iCount<g_configData.m_iNrOfActivePlayers;iCount++)
		{
			//wenn lebendig dann auch bewegen
			if (m_ppPlayer[iCount]->m_pSnake->alive())
			{
				//einer mehr lebendig!
				iAliveCount++;

				//Bewegen
				iTile=m_ppPlayer[iCount]->m_pSnake->move(&m_Field);

				//Sound fr Drehbewegung?
				iSoundLocation=m_ppPlayer[iCount]->m_pSnake->getSoundFX();
				if (iSoundLocation>=1024)
				{
					iSoundLocation-=1024;
					g_xfmodHelper.playSample(m_pfsTurn,iSoundLocation*255/iFieldSizeX);
				}
				
				//was Essbares gefunden?
				if (iTile>=g_TileSetData.m_iFirstEatable
					&& iTile<=g_TileSetData.m_iLastFree)
				{
					//Partikel...
					m_ppPlayer[iCount]->m_pSnake->emit(&m_Field,1,15);

					//Sound fr Fressen spielen 
					g_xfmodHelper.playSample(m_pfsEat,iSoundLocation*255/iFieldSizeX);

					//Schlange verlngern
					m_ppPlayer[iCount]->m_pSnake->add(m_iFoodCount);

					//einen mickrigen Punkt gibts
					m_ppPlayer[iCount]->addPoints(1);

					//will neues haben!
					m_bMoreFood=true;
				}
				
				//Kollision = TOD
				if (iTile>=g_TileSetData.m_iLastFree)
				{
					//Partikel...
					m_ppPlayer[iCount]->m_pSnake->emit(&m_Field,5,25,true);

					m_ppPlayer[iCount]->m_pSnake->kill(&m_Field,iTile);
					g_xfmodHelper.playSample(m_pfsDead);
				}
			}

			//wenn ntig neues Futter machen
			if (m_bMoreFood)
			{
				//Feld suchen, am Rand zwei frei lassen
				iTmpX=2+rand()%(iFieldSizeX-4);
				iTmpY=2+rand()%(iFieldSizeY-4);
				
				//wenn total leer setzen, sonst Pech gehabt
				if (m_Field.isTotalEmpty(iTmpX,iTmpY))
				{
					m_Field.setTile(iTmpX,iTmpY,32+rand()%6);
					m_bMoreFood=false;
					m_iFoodCount+=4;
				}
			}
		}
		
		
		
		//wenn einer oder keiner lebt, beenden
		if (iAliveCount<2)
		{
			//Endbildschirm unentschieden
			m_iGameStatus=29;
			
			//lebt noch wer?
			for(iCount=0;iCount<g_configData.m_iNrOfActivePlayers;iCount++)
			{
				if (m_ppPlayer[iCount]->m_pSnake->alive())
				{
					//Player iCount gewinnt!
					m_iGameStatus=20+iCount;
				}
			}
			
			if (m_iGameStatus!=29)
			{
				g_xfmodHelper.playSample(m_pfsWon);
			}
		}
		
		break;
/////////////////////////////////////////////////////////////////////////////////////
	//Spielablauf Challenge
/////////////////////////////////////////////////////////////////////////////////////
	case Challenge:
		//wenn lebendig dann auch bewegen
		if (m_ppPlayer[0]->m_pSnake->alive())
		{
			//noch lebendig!
			iAliveCount++;

			//Bewegen
			iTile=m_ppPlayer[0]->m_pSnake->move(&m_Field);

			//Sound fr Drehbewegung?
			iSoundLocation=m_ppPlayer[0]->m_pSnake->getSoundFX();
			if (iSoundLocation>=1024)
			{
				iSoundLocation-=1024;
				g_xfmodHelper.playSample(m_pfsTurn,iSoundLocation*255/iFieldSizeX);
			}
			
			//Sound fr FoodTimer?
			if (m_iFoodSound*1000<m_iTimePassed-m_iFoodTime)
			{
				m_iFoodSound++;
				if (m_iFoodSound>=4 && m_iFoodSound<=8)
					g_xfmodHelper.playSample(m_pfsTime1);
				if (m_iFoodSound==9)
					g_xfmodHelper.playSample(m_pfsTime2);
			}

			//was Essbares gefunden?
			if (iTile>=g_TileSetData.m_iFirstEatable
				&& iTile<=g_TileSetData.m_iLastFree)
			{
				//Sound fr Fressen spielen 
				g_xfmodHelper.playSample(m_pfsEat,iSoundLocation*255/iFieldSizeX);

				//Schlange verlngern
				m_ppPlayer[0]->m_pSnake->add(m_iFoodCount);

				//ZusatzPunkte fr Zeit berechnen
				m_iFoodTime=m_iFoodTime-m_iTimePassed+8000;
				if (m_iFoodTime>5000)
					m_iFoodTime=5000;
				if (m_iFoodTime<0)
					m_iFoodTime=0;
				//Partikel...
				m_ppPlayer[0]->m_pSnake->emit(&m_Field,1,m_iFoodTime/250+10);
				m_iFoodTime=(m_iFoodTime*m_iFoodCount)/2500;
				
				//Punkte verteilen
				m_ppPlayer[0]->addPoints(m_iFoodCount+m_iFoodTime);

				//will neues haben!
				m_bMoreFood=true;
				m_iFoodSound=99;
				
			}
			
			//Kollision = TOD
			if (iTile>=g_TileSetData.m_iLastFree)
			{
				//Partikel...
				m_ppPlayer[0]->m_pSnake->emit(&m_Field,5,30,true);

				m_ppPlayer[0]->m_pSnake->kill(&m_Field,iTile);
				g_xfmodHelper.playSample(m_pfsDead);
			}
		
		}
		//wenn ntig neues Futter machen
		if (m_bMoreFood)
		{
			//Feld suchen, am Rand zwei frei lassen
			iTmpX=2+rand()%(iFieldSizeX-4);
			iTmpY=2+rand()%(iFieldSizeY-4);
			
			//wenn total leer setzen, sonst Pech gehabt
			if (m_Field.isTotalEmpty(iTmpX,iTmpY))
			{
				m_Field.setTile(iTmpX,iTmpY,32+rand()%6);
				m_bMoreFood=false;
				if (m_iFoodCount<40)
					m_iFoodCount+=1;
				m_iFoodTime=m_iTimePassed;
				m_iFoodSound=1;
			}
		}

		//wenn Player tot ist, Spiel beenden
		if (iAliveCount==0)
		{
			// ins Menu gehen...
			m_iMenuStatus=0;
			m_iGameStatus=3;

			if (g_configData.m_bWrapAround)
			{
				iCount=2*g_configData.getLevelNr(0)+1;
			}
			else
			{
				iCount=2*g_configData.getLevelNr(0);
			}

			if (m_ppPlayer[0]->addPoints(0) > g_hsData.getMinimumPoints(iCount))
			{
				m_iGameStatus=100+iCount;
			}
		}
		
		break;
/////////////////////////////////////////////////////////////////////////////////////
	//Spielablauf CaptureTheFlag
/////////////////////////////////////////////////////////////////////////////////////
	case CaptureTheFlag:
		for(iCount=0;iCount<g_configData.m_iNrOfActivePlayers;iCount++)
		{
			//wenn lebendig dann auch bewegen
			if (m_ppPlayer[iCount]->m_pSnake->alive())
			{
				//einer mehr lebendig!
				iAliveCount++;

				//Schlange verlngern
				m_ppPlayer[iCount]->m_pSnake->add(1);
				//Bewegen
				iTile=m_ppPlayer[iCount]->m_pSnake->move(&m_Field);

				//Sound fr Drehbewegung?
				iSoundLocation=m_ppPlayer[iCount]->m_pSnake->getSoundFX();
				if (iSoundLocation>=1024)
				{
					iSoundLocation-=1024;
					g_xfmodHelper.playSample(m_pfsTurn,iSoundLocation*255/iFieldSizeX);
				}
				
				//mit der Flagge die gegnerische Basis erreicht?
				if (m_iFoodCount==iCount)
				{
					//emitieren, wenn Spieler die Flagge hat
					m_ppPlayer[iCount]->m_pSnake->emit(&m_Field,2+iCount,1);


					bTmp=false;
					//Spieler eins auf Basis Blau?
					if (iCount==0 && iTile==g_TileSetData.m_iBlueBase)
						bTmp=true;
					//Spieler zwei auf Basis rot?
					if (iCount==1 && iTile==g_TileSetData.m_iRedBase)
						bTmp=true;

					if (bTmp)
					{
						//Flagge wech
						m_iFoodCount=-1;

						//5 Punkte
						m_ppPlayer[iCount]->addPoints(5);

						if (iCount==0)
						{
							m_ppPlayer[iCount]->m_pSnake->emit(&m_Field,2,25);
							g_xfmodHelper.playSample(m_pfsRedScores);
						}
						else
						{
							m_ppPlayer[iCount]->m_pSnake->emit(&m_Field,3,25);
							g_xfmodHelper.playSample(m_pfsBlueScores);
						}

						m_ppPlayer[iCount]->m_pSnake->kill(&m_Field,iTile);
						m_ppPlayer[iCount]->m_pSnake->remove(&m_Field);
						m_ppPlayer[iCount]->m_pSnake->reset(m_Field.getStartX(iCount), 
															m_Field.getStartY(iCount), 
															m_Field.getStartDirection(iCount));
					}
				}


				//Flagge gefunden?
				if (iTile==g_TileSetData.m_iFlag)
				{
					//1 Punkt 
					m_ppPlayer[iCount]->addPoints(1);

					//Flagge zuteilen Flagge?
					m_iFoodCount=iCount;

					//will neues haben!
					m_bMoreFood=true;

					m_ppPlayer[iCount]->m_pSnake->emit(&m_Field,4,25);

					// Sound spielen
					if (iCount==0)
						g_xfmodHelper.playSample(	m_pfsRedGotFlag,
													iSoundLocation*255/iFieldSizeX);
					else
						g_xfmodHelper.playSample(	m_pfsBlueGotFlag,
													iSoundLocation*255/iFieldSizeX);
				}
				
				//Kollision = Neustart
				if (iTile>=g_TileSetData.m_iLastFree)
				{
					m_ppPlayer[iCount]->m_pSnake->emit(&m_Field,5,20,true);

					m_ppPlayer[iCount]->m_pSnake->kill(&m_Field,iTile);
					m_ppPlayer[iCount]->m_pSnake->remove(&m_Field);
					m_ppPlayer[iCount]->m_pSnake->reset(m_Field.getStartX(iCount), 
														m_Field.getStartY(iCount), 
														m_Field.getStartDirection(iCount));
					//Flagge is wech
					if (m_iFoodCount==iCount)
						m_iFoodCount=-1;
					g_xfmodHelper.playSample(m_pfsDead);
				}
			}

			//wenn ntig neues Futter machen
			if (m_bMoreFood)
			{
				//Feld suchen, am Rand zwei frei lassen
				iTmpX=m_Field.getStartX(2)+rand()%(iFieldSizeX-2*m_Field.getStartX(2));
				iTmpY=m_Field.getStartY(2)+rand()%(iFieldSizeY-2*m_Field.getStartY(2));
				
				//wenn total leer setzen, sonst Pech gehabt
				if (m_Field.isTotalEmpty(iTmpX,iTmpY))
				{
					m_Field.setTile(iTmpX,iTmpY,g_TileSetData.m_iFlag);
					m_bMoreFood=false;
				}
			}
		}
		
			
		break;
/////////////////////////////////////////////////////////////////////////////////////
	//Spielablauf EatEmAll
/////////////////////////////////////////////////////////////////////////////////////
	case EatEmAll:
		for(iCount=0;iCount<g_configData.m_iNrOfActivePlayers;iCount++)
		{
			//wenn lebendig dann auch bewegen
			if (m_ppPlayer[iCount]->m_pSnake->alive())
			{
				//Bewegen
				iTile=m_ppPlayer[iCount]->m_pSnake->move(&m_Field);

				//Sound fr Drehbewegung?
				iSoundLocation=m_ppPlayer[iCount]->m_pSnake->getSoundFX();
				if (iSoundLocation>=1024)
				{
					iSoundLocation-=1024;
					g_xfmodHelper.playSample(m_pfsTurn,iSoundLocation*255/iFieldSizeX);
				}

				//was Essbares gefunden?
				if (iTile>=g_TileSetData.m_iFirstEatable
					&& iTile<=g_TileSetData.m_iLastFree)
				{
					//Partikel...
					m_ppPlayer[iCount]->m_pSnake->emit(&m_Field,1,20);

					//Schlange verlngern
					m_ppPlayer[iCount]->m_pSnake->add(15);

					//will neues haben!
					m_bMoreFood=true;

					g_xfmodHelper.playSample(m_pfsStar,iSoundLocation*255/iFieldSizeX);
				}
				
				//abliefern?
				if (iTile==g_TileSetData.m_iRainbow)
				{
					iTmpX=m_ppPlayer[iCount]->m_pSnake->remove(&m_Field)-1;
					iTmpY=m_ppPlayer[iCount]->addPoints(-iTmpX);
					m_ppPlayer[iCount]->m_pSnake->add(1);
					g_xfmodHelper.playSample(m_pfsRainbow);

					//Partikel...
					m_ppPlayer[iCount]->m_pSnake->emit(&m_Field,4,3+iTmpX/2);
					

					//alle Punkte weg?
					if (iTmpY<=0)
					{
						m_ppPlayer[iCount]->addPoints(-iTmpY);
						iAliveCount++;
					}
				}

				//Kollision mit Hinderniss = Neustart
				if (iTile>=g_TileSetData.m_iLastFree && iTile<g_TileSetData.m_iFirstSnake)
				{
					//Partikel...
					m_ppPlayer[iCount]->m_pSnake->emit(&m_Field,5,20,true);

					m_ppPlayer[iCount]->m_pSnake->kill(&m_Field,iTile);
					m_ppPlayer[iCount]->m_pSnake->remove(&m_Field);
					m_ppPlayer[iCount]->m_pSnake->reset(m_Field.getStartX(iCount), 
														m_Field.getStartY(iCount), 
														m_Field.getStartDirection(iCount));
					g_xfmodHelper.playSample(m_pfsDead);
				}

				//Kollision mit Schlange = ?
				if (iTile>=g_TileSetData.m_iFirstSnake)
				{	
					iTmpX=iNumberOfPlayers-1;
					while (iTile<g_TileSetData.getPlayerTileOffset(iTmpX))
					{
						iTmpX--;
					}
					
					if (iCount==iTmpX)
					{	//mit sich selbst  = Neustart
						
						//Partikel...
						m_ppPlayer[iCount]->m_pSnake->emit(&m_Field,5,20,true);
					
						m_ppPlayer[iCount]->m_pSnake->kill(&m_Field,iTile);
						m_ppPlayer[iCount]->m_pSnake->remove(&m_Field);
						m_ppPlayer[iCount]->m_pSnake->reset(m_Field.getStartX(iCount), 
														m_Field.getStartY(iCount), 
														m_Field.getStartDirection(iCount));
						g_xfmodHelper.playSample(m_pfsDead);
					}
					else
					{	//mit einem Gegner = schwanz abhacken und Teile umverteilen


						iTmpY=m_ppPlayer[iCount]->m_pSnake->removeUntilHead(	
															&m_Field,
															m_ppPlayer[iTmpX]->m_pSnake);
						m_ppPlayer[iCount]->m_pSnake->add(iTmpY/2);
						m_ppPlayer[iTmpX]->m_pSnake->add(iTmpY/2+1);
						
						//Partikel...
						m_ppPlayer[iCount]->m_pSnake->emit(&m_Field,5,iTmpY/2+2,true);

						g_xfmodHelper.playSample(m_pfsEat,iSoundLocation*255/iFieldSizeX);
					}
				}
			}

			//wenn ntig neues Futter machen
			if (m_bMoreFood)
			{
				//Feld suchen, am Rand zwei frei lassen
				iTmpX=2+rand()%(iFieldSizeX-4);
				iTmpY=2+rand()%(iFieldSizeY-4);
				
				//wenn total leer setzen, sonst Pech gehabt
				if (m_Field.isTotalEmpty(iTmpX,iTmpY))
				{
					m_Field.setTile(iTmpX,iTmpY,48);
					m_bMoreFood=false;
				}
			}
		}
		
		
		
		//wenn einer keine Punkte mehr hat, beenden
		if (iAliveCount>0)
		{
			//wer hat 0 points
			for(iCount=0;iCount<g_configData.m_iNrOfActivePlayers;iCount++)
			{
				if (m_ppPlayer[iCount]->addPoints(0)==0)
				{
					//Player iCount gewinnt!
					m_iGameStatus=30+iCount;
				}
			}
			
			//Endbildschirm unentschieden, bei mehreren
			if (iAliveCount!=1)
			{
				m_iGameStatus=39;
			}
				g_xfmodHelper.playSample(m_pfsWon);

		}
		
		break;
/////////////////////////////////////////////////////////////////////////////////////
	}

	//feste Tasten abfragen
	switch(m_wWMKey)
	{
	case VK_PAUSE:
		m_iMenuStatus=0;
		m_iGameStatus=2;
		g_xfmodHelper.playSample(m_pfsMenu);
		break;
	case VK_ESCAPE:
		m_iMenuStatus=2;
		m_iGameStatus=2;
		g_xfmodHelper.playSample(m_pfsMenu);
		break;
	}

	m_wWMKey=(WPARAM)-1;
		
}
	
/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPGame::endGame
/////////////////////////////////////////////////////////////////////////////////////
// Info:	beendet das Spiel (deletet Spieler...)
/////////////////////////////////////////////////////////////////////////////////////
void PPGame::endGame()
{
	int iCount;

	//Spieler destroyen
	for(iCount=0;iCount<3;iCount++)
	{
		if (m_ppPlayer[iCount]!=NULL)
		{
			delete m_ppPlayer[iCount];
			m_ppPlayer[iCount]=NULL;
		}
	}
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPGame::runMenu
/////////////////////////////////////////////////////////////////////////////////////
// Info:	fhrt das InGameMenu aus
/////////////////////////////////////////////////////////////////////////////////////
void PPGame::runMenu()
{
	switch(m_wWMKey)
	{
	case VK_DOWN:
		m_iMenuStatus++;
		if (m_iMenuStatus==3) m_iMenuStatus=0;
		g_xfmodHelper.playSample(m_pfsMenu);
		break;
	case VK_UP:
		m_iMenuStatus--;
		if (m_iMenuStatus==-1) m_iMenuStatus=2;
		g_xfmodHelper.playSample(m_pfsMenu);
		break;
	case VK_RETURN:
		switch(m_iMenuStatus)
		{
		case 0://resume
			m_iTimePassed=m_iLastTick;
			m_iGameStatus=1;
			g_xfmodHelper.playSample(m_pfsMenu);
			break;
		case 1://Restart
			endGame();
			prepareGame();
			break;
		case 2://End Game
			m_stateNext=Menu;
			break;
		}
		break;
	case VK_PAUSE:
		m_iTimePassed=m_iLastTick;
		m_iGameStatus=1;
		g_xfmodHelper.playSample(m_pfsMenu);
		break;
	case VK_ESCAPE:
		m_iTimePassed=m_iLastTick;
		m_iGameStatus=1;
		g_xfmodHelper.playSample(m_pfsMenu);
		break;
	}

	m_wWMKey=(WPARAM)-1;
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPGame::runGameOver
/////////////////////////////////////////////////////////////////////////////////////
// Info:	fhrt das GameOver Menu aus
/////////////////////////////////////////////////////////////////////////////////////
void PPGame::runGameOver()
{
	switch(m_wWMKey)
	{
	case VK_DOWN:
		m_iMenuStatus++;
		if (m_iMenuStatus==2) m_iMenuStatus=0;
		g_xfmodHelper.playSample(m_pfsMenu);
		break;
	case VK_UP:
		m_iMenuStatus--;
		if (m_iMenuStatus==-1) m_iMenuStatus=1;
		g_xfmodHelper.playSample(m_pfsMenu);
		break;
	case VK_RETURN:
		switch(m_iMenuStatus)
		{
		case 0://Restart
			endGame();
			prepareGame();
			break;
		case 1://End Game
			m_stateNext=Menu;
			break;
		}
		break;
	}

	m_wWMKey=(WPARAM)-1;
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPGame::checkKeys_DEF
/////////////////////////////////////////////////////////////////////////////////////
// Info:	wartet auf Tasten-Druck und macht dann entsprechend weiter
/////////////////////////////////////////////////////////////////////////////////////
void PPGame::checkKeys_DEF()
{
	int iTmp;
	int iTmpPoints[3];
	int iCount;

	if (m_wWMKey==VK_RETURN)
	{
		switch(m_iGameStatus)
		{
			case 10://SinglePlayer /Level done
				//Bonus-Punkte
				m_ppPlayer[0]->addPoints(
					g_configData.getLevelNr()*10*(225-g_configData.m_iGameSpeed)/25);

				//naechsten Level waehlen
				if(g_configData.getLevelNr()<iNumberOfSinglePlayLevel)
				{
					g_configData.getLevelNr(1);
				}
				else
				{
					g_configData.getLevelNr(-iNumberOfSinglePlayLevel);
					if (g_configData.m_iGameSpeed>50)
						g_configData.m_iGameSpeed-=25;						
				}					
				
				//Level freischalten
				if (g_configData.m_iMapsFree<g_configData.getLevelNr())
					g_configData.m_iMapsFree=g_configData.getLevelNr();

				iTmpPoints[0]=m_ppPlayer[0]->addPoints(0);
				endGame();
				prepareGame();
				m_ppPlayer[0]->addPoints(iTmpPoints[0]);
				break;

			case 20://MultiPlayer Gewinn Anzeige
			case 21:
			case 22:
			case 29:
				for(iCount=0;iCount<g_configData.m_iNrOfActivePlayers;iCount++)
				{
					iTmpPoints[iCount]=m_ppPlayer[iCount]->addPoints(0);
				}
				iTmp=m_iGameStatus-20;
				endGame();
				prepareGame();
				for(iCount=0;iCount<g_configData.m_iNrOfActivePlayers;iCount++)
				{
					m_ppPlayer[iCount]->addPoints(iTmpPoints[iCount]);
				}
				if (iTmp<3)
					m_ppPlayer[iTmp]->addPoints(10);
				break;

			case 30://EatEmAll Gewinn Anzeige
			case 31:
			case 32:
			case 39:
				m_iMenuStatus=0;
				m_iGameStatus=3;
				g_xfmodHelper.playSample(m_pfsMenu);
				break;
		}
	}

	if (m_wWMKey==VK_NEXT)
	{
		switch(m_iGameStatus)
		{
			case 20:
			case 21:
			case 22:
			case 29:
				g_configData.getLevelNr(-1);
				g_configData.loadLevel(&m_Field);
				g_xfmodHelper.playSample(m_pfsMenu);
				break;
		}
	}

	if (m_wWMKey==VK_PRIOR)
	{
		switch(m_iGameStatus)
		{
			case 20:
			case 21:
			case 22:
			case 29:
				g_configData.getLevelNr(1);
				g_configData.loadLevel(&m_Field);
				g_xfmodHelper.playSample(m_pfsMenu);
				break;
		}
	}

	if (m_iGameStatus>=100 && m_iGameStatus<200) //HighSore Eintrag
	{
		if (m_wWMKey==VK_RETURN)
		{
			g_hsData.setEntry(	m_iGameStatus-100,
								m_pcPlayerName,
								m_ppPlayer[0]->addPoints(0));
			g_hsData.save("highscr.dat");

			m_iMenuStatus=0;
			m_iGameStatus=3;

			g_xfmodHelper.playSample(m_pfsMenu);
		}

		iCount=strlen(m_pcPlayerName);
		
		if (iCount<iHighScoreNameLength)
		{
			if (m_wWMKey>='A' && m_wWMKey<='Z')
			{
				m_pcPlayerName[iCount]=m_wWMKey-'A'+'a';
				m_pcPlayerName[iCount+1]=0;
				g_xfmodHelper.playSample(m_pfsMenu);
			}

			if (m_wWMKey==' ')
			{
				m_pcPlayerName[iCount]=m_wWMKey;
				m_pcPlayerName[iCount+1]=0;
				g_xfmodHelper.playSample(m_pfsMenu);
			}

			if (m_wWMKey>='0' && m_wWMKey<='9')
			{
				m_pcPlayerName[iCount]=m_wWMKey;
				m_pcPlayerName[iCount+1]=0;
				g_xfmodHelper.playSample(m_pfsMenu);
			}

		}

		if (iCount>0)
		{
			if (m_wWMKey==VK_BACK)
			{
				m_pcPlayerName[iCount-1]=0;
				g_xfmodHelper.playSample(m_pfsMenu);
			}
		}

	}

	m_wWMKey=(WPARAM)-1;
}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPGame::showScreen_DEF
/////////////////////////////////////////////////////////////////////////////////////
// Info:	zeigt diverse Menus an
/////////////////////////////////////////////////////////////////////////////////////
void PPGame::showScreen_DEF()
{
	char	pcText[64];

	m_xsMenuHead.m_lX=384;
	m_xsMenuHead.m_lY=334;
	
	m_xsMenu.m_lX=384;
	m_xsMenu.m_lY=354;
	m_xsMenu.m_lFrame=0;
	m_xsMenu.blit(m_pxdisplayActual);

	switch(m_iGameStatus)
	{
	case 10://SinglePlayer /Level done
			m_xsMenuHead.m_lFrame=0;
			m_xsMenuHead.blit(m_pxdisplayActual);
			m_xfChars.textOut(m_pxdisplayActual,449,367,"level complete");
			sprintf(	pcText,
						"bonus: %04d points",
						g_configData.getLevelNr()*10*(225-g_configData.m_iGameSpeed)/25);
			m_xfChars.textOut(m_pxdisplayActual,431,389,pcText);
			m_xfChars.textOut(m_pxdisplayActual,480,413,"[enter]");
			break;
	case 20://DeathMatch / Spieler 1 gewinnt
			m_xsMenuHead.m_lFrame=1;
			m_xsMenuHead.blit(m_pxdisplayActual);
			m_xfChars.textOut(m_pxdisplayActual,440,378,"player one wins!");
			m_xfChars.textOut(m_pxdisplayActual,417,413,"[enter, page up-down]");
			break;
	case 21://DeathMatch / Spieler 2 gewinnt
			m_xsMenuHead.m_lFrame=1;
			m_xsMenuHead.blit(m_pxdisplayActual);
			m_xfChars.textOut(m_pxdisplayActual,440,378,"player two wins!");
			m_xfChars.textOut(m_pxdisplayActual,417,413,"[enter, page up-down]");
			break;
	case 22://DeathMatch / Spieler 3 gewinnt
			m_xsMenuHead.m_lFrame=1;
			m_xsMenuHead.blit(m_pxdisplayActual);
			m_xfChars.textOut(m_pxdisplayActual,431,378,"player three wins!");
			m_xfChars.textOut(m_pxdisplayActual,417,413,"[enter, page up-down]");
			break;
	case 29://DeathMatch / unentschieden
			m_xsMenuHead.m_lFrame=1;
			m_xsMenuHead.blit(m_pxdisplayActual);
			m_xfChars.textOut(m_pxdisplayActual,453,378,"it is a draw!");
			m_xfChars.textOut(m_pxdisplayActual,417,413,"[enter, page up-down]");
			break;
	case 30://EatEmAll / Spieler 1 gewinnt
			m_xsMenuHead.m_lFrame=1;
			m_xsMenuHead.blit(m_pxdisplayActual);
			m_xfChars.textOut(m_pxdisplayActual,440,378,"player one wins!");
			m_xfChars.textOut(m_pxdisplayActual,480,413,"[enter]");
			break;
	case 31://EatEmAll / Spieler 2 gewinnt
			m_xsMenuHead.m_lFrame=1;
			m_xsMenuHead.blit(m_pxdisplayActual);
			m_xfChars.textOut(m_pxdisplayActual,440,378,"player two wins!");
			m_xfChars.textOut(m_pxdisplayActual,480,413,"[enter]");
			break;
	case 32://EatEmAll / Spieler 3 gewinnt
			m_xsMenuHead.m_lFrame=1;
			m_xsMenuHead.blit(m_pxdisplayActual);
			m_xfChars.textOut(m_pxdisplayActual,431,378,"player three wins!");
			m_xfChars.textOut(m_pxdisplayActual,480,413,"[enter]");
			break;
	case 39://EatEmAll / unentschieden
			m_xsMenuHead.m_lFrame=1;
			m_xsMenuHead.blit(m_pxdisplayActual);
			m_xfChars.textOut(m_pxdisplayActual,453,378,"it is a draw!");
			m_xfChars.textOut(m_pxdisplayActual,480,413,"[enter]");
			break;
	}

	if (m_iGameStatus>=100 && m_iGameStatus<200) //HighSore Eintrag
	{
			m_xsMenuHead.m_lFrame=2;
			m_xsMenuHead.blit(m_pxdisplayActual);
			m_xfChars.textOut(m_pxdisplayActual,453,365,"new highscore");
			m_xfChars.textOut(m_pxdisplayActual,444,385,"enter your name");
			m_xfChars.textOut(m_pxdisplayActual,467,408,m_pcPlayerName);
			m_xfChars.textOut(	m_pxdisplayActual,
								467+strlen(m_pcPlayerName)*9,
								414,
								"-");
	}

}

/////////////////////////////////////////////////////////////////////////////////////
// Methode:			PPGame::wndProc
/////////////////////////////////////////////////////////////////////////////////////
// Info:	wndProc der Game Klasse
/////////////////////////////////////////////////////////////////////////////////////
void PPGame::wndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
	case WM_KEYDOWN:
		m_wWMKey=wParam;
		break;
	}

	if (!g_bIsActive && m_iGameStatus==1)
	{
		//Game auf Pause schalten
		m_iMenuStatus=0;
		m_iGameStatus=2;
	}
}

/////////////////////////////////////////////////////////////////////////////////////
// Ende der Datei:	PPGame.cpp
/////////////////////////////////////////////////////////////////////////////////////
