/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		PPIntro.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Christian Roesch
//
// Erstelldatum:	24.07.2001
// letzte nderung:	21.09.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Das TNG-Soft Intro
/////////////////////////////////////////////////////////////////////////////////////


#ifndef _PPIntro_H
#define _PPIntro_H

// includes
#include "PPart.h"
#include "global.h"
#include "XGameSDK\XDisplay.h"
#include "XGameSDK\XSprite.h"
#include "XGameSDK\XInput.h"


// Klassen-Deklaration

class	PPIntro : public PPart
{
public:
	virtual HRESULT initialize(XDisplay* pxdisplayDest);
	virtual HRESULT uninitialize(void);

	virtual State run(int iTime, XDisplay* pxdisplayDest);

	virtual HRESULT recoverFromFocusLost(void);

	virtual void wndProc(HWND	hWnd,
						 UINT	message,
						 WPARAM	wParam,
						 LPARAM	lParam);

	State getState(void)
	{
		return Intro;
	}

protected:

private:
	int				m_iTimePassed;
	bool			m_bFinish;

	XSurface		m_xsurfBackground;
	XSurface		m_xsurfSnakeLogo;
	XSprite			m_xsTNG;
	XSprite			m_xsSOFT;
	XSprite			m_xsStarFX;

	FSOUND_SAMPLE*  m_pfsSound1;
	FSOUND_SAMPLE*  m_pfsSound2;
};

#endif // _PPIntro_H

class	PPIntro;

/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		PPIntro.h
/////////////////////////////////////////////////////////////////////////////////////
