/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		PPMenu.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Christian Roesch
//
// Erstelldatum:	01.08.2001
// letzte nderung:	21.09.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Menu-Implemetation
/////////////////////////////////////////////////////////////////////////////////////


#ifndef _PPMenu_H
#define _PPMenu_H

// includes
#include <stdio.h>
#include <string.h>
#include "Field.h"
#include "PPart.h"
#include "global.h"
#include "XGameSDK\XDisplay.h"
#include "XGameSDK\XSprite.h"
#include "XGameSDK\XFont.h"
#include "XGameSDK\XInput.h"

// Klassen-Deklaration

class	PPMenu : public PPart
{
public:
	virtual HRESULT initialize(XDisplay* pxdisplayDest);
	virtual HRESULT uninitialize(void);

	virtual State run(int iTime, XDisplay* pxdisplayDest);

	virtual HRESULT recoverFromFocusLost(void);

	virtual void wndProc(HWND	hWnd,
						 UINT	message,
						 WPARAM	wParam,
						 LPARAM	lParam);

	State getState(void)
	{
		return Menu;
	}

protected:

private:
	int			analyzeKeys(void);
	void		renderSubMenu(XDisplay* pxdisplayDest, int iNr, int iPosX, int iPosY);
	void		renderKeyConfig(XDisplay* pxdisplayDest, int iPosX, int iPosY);
	void		doKeyConfig(int iKey);
	int			processSubMenu(int iNr);

	XSurface	m_xsurfBackground;
	XSprite		m_xsPanels;
	XSprite		m_xsScreenHolder;
	XSprite		m_xsScreenBack;
	XSprite		m_xsMoveIcons;
	
	XSurface	m_xsurfMapPreview;
	XSprite		m_xsSmallTileSet;
	Field		m_fieldPreview;

	XSprite		m_xsSpeedBar;
	XSprite		m_xsSpeedButton;

	XFont		m_xfChars;

	int			m_iChoosen;
	int			m_iChoosenState;
	int			m_iKeyPressed;
	int			m_iChoosenTime;

	State		m_stateNext;

	FSOUND_SAMPLE*	m_pfsUp;
	FSOUND_SAMPLE*	m_pfsDown;
	FSOUND_SAMPLE*	m_pfsInc;
	FSOUND_SAMPLE*	m_pfsDec;
	FSOUND_SAMPLE*	m_pfsMisc;

	FMUSIC_MODULE*	m_pfmMenuMuzak;
};

#endif // _PPMenu_H

class	PPMenu;

/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		PPMenu.h
/////////////////////////////////////////////////////////////////////////////////////