/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		TileSetData.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Christian Roesch
//
// Erstelldatum:	06.08.2001
// letzte nderung:	07.09.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:	Diese Datei enthlt die Daten ber das TileSet
/////////////////////////////////////////////////////////////////////////////////////


#ifndef _TileSetData_H
#define _TileSetData_H

// includes
#include "global.h"


// Klassen-Deklaration
class	TileSetData
{
public:
	TileSetData(void);
bool	isTileFree(int iTileId);
bool	isTileEatable(int iTileId);
int		getPlayerTileOffset(int iPlayerNr);
int		getSnakeTileOffset(int iPrevDir, int iNextDir);

const int m_iLastFree;		//hchste Nummer eines betretbaren Teils
const int m_iFirstEatable;	//erste Nummer eines essbaren Teils
const int m_iLastEmpty;		//hchste Nummer, die vollkommen leer ist
const int m_iFirstSnake;	//erstes SnakeTeil
/////////////////////////////////////////////////////////////////////////////////////
// mit folgender Tabelle kann man schauen, um was fr ein Tile es sich handelt
/////////////////////////////////////////////////////////////////////////////////////
//Bedeutung					erstes Tile			letztes Tile			
//vollkommen leer	:		0					m_iLastEmpty			
//betretbar			:		0					m_iLastFree				
//essbar			:		m_iFirstEatable		m_iLastFree				
//fest (Steine)		:		m_iLastEmpty+1		m_iFirstSnake-1			
//Schlange			:		m_iFirstSnake		256				
/////////////////////////////////////////////////////////////////////////////////////
const int m_iRainbow;	//das Regenbogenfeld
const int m_iFlag;		//Flagge
const int m_iRedBase;	//rote Basis
const int m_iBlueBase;	//blaue Basis
protected:

private:
int m_iPlayerOffsets[3];
int m_iSnakeOffsets[5][5];
};

#endif // _TileSetData_H

class	TileSetData;

/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		TileSetData.h
/////////////////////////////////////////////////////////////////////////////////////
