/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		XFModHelper.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Christian Roesch
//
// Erstelldatum:	09.09.2001
// letzte nderung:	06.11.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:	hilft bei der Benutzung von FMod, kapselt die kritischen FMod-Funktionen			
//			um die Arbeit zur Fehlerbehandlungen zu vereinfachen. Es werden ebenfalls
//			sinnvolle DefaultParameter eingesetzt.
//			(Diese Klasse ist nicht dazu gedacht, FMod vollstndig zu kapseln...)
/////////////////////////////////////////////////////////////////////////////////////


#ifndef _XFModHelper_H
#define _XFModHelper_H

// includes
#include "XLogging.h"
#include <fmod.h>
#include <fmod_errors.h>

// Klassen-Deklaration

class	XFModHelper
{
public:
		XFModHelper(void);
		~XFModHelper(void);

bool	initialize(			int iOutputType=FSOUND_OUTPUT_DSOUND,
							int iDriver=0,
							int iMixRate=44100,
							int iMaxSoftwareChannels=32,
							unsigned int uiFlags=0);
void	uninitialize(void);

FSOUND_SAMPLE*	loadSample( const char *pcName,
							int iIndex=FSOUND_FREE,
							unsigned int iMode=FSOUND_NORMAL);

FMUSIC_MODULE*  loadModule( const char *pcName);

int playSample(				FSOUND_SAMPLE* psampleDest, 
							int iPan=128, 
							int iChannel=FSOUND_FREE);

int playModule(				FMUSIC_MODULE* pmusicDest,
							int iChannelsNotToUse=8,
							int iMinVolume=32);

	int	 m_iSFXVolume;//0-255
	int	 m_iMusicVolume;//0-255

protected:

private:
	bool m_bInitialized;
	int  m_iSWChannels;

};

#endif // _XFModHelper_H

class	XFModHelper;

/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		XFModHelper.h
/////////////////////////////////////////////////////////////////////////////////////
