/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		XInput.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Baal
//
// Version			1.1
// Erstelldatum:	04.09.2000
// letzte nderung:	29.07.2001 (by TGGC)
/////////////////////////////////////////////////////////////////////////////////////
// Info:			Klasse, um Daten der Tastatur und der Maus mittels Direct-Input
//					abzufragen.
//					Daten werden ber den aktuellen Status des Gertes ermittelt
/////////////////////////////////////////////////////////////////////////////////////
// Copyright 2000 by x-treme
/////////////////////////////////////////////////////////////////////////////////////


#define WIN32_LEAN_AND_MEAN		// Selten genutzte Teile aus Win-Header ausschliessen

#ifndef _XINPUT_H
#define _XINPUT_H


// Um die Nutzung unter DirectX 8 zu gewhrleisten
#define DIRECTINPUT_VERSION 0x0700


// Standard-Includes
#include <windows.h>
#include <dinput.h>


// XGame-Includes
#include "XLogging.h"


// Klassen-Deklaration
class	XInput
{
	private:
		HRESULT					setJoystickProperties(int nRange, unsigned int nDeadZone);
		
		LPDIRECTINPUT7			m_lpDirectInput;
		LPDIRECTINPUTDEVICE7	m_lpJoystickDevice;
		LPDIRECTINPUTDEVICE7	m_lpKeyboardDevice;
		LPDIRECTINPUTDEVICE7	m_lpMouseDevice;

		RECT					*m_lpRect;
		
	protected:

	public:
		XInput();
		~XInput();
		
		HRESULT initialize(HINSTANCE hInstance);
		HRESULT activateJoystick(HWND hWnd, int nRange = 1000, unsigned int nDeadZone = 1000);
		HRESULT activateKeyboard(HWND hWnd);
		HRESULT activateMouse(HWND hWnd, int nXStartPos = 0, int nYStartPos = 0);
		HRESULT getJoystickData();
		HRESULT getKeyboardData();
		HRESULT	getKeyboardText(DWORD dwNrOfKey,char* pcText,int iMaxLength);
		HRESULT getMouseData();
		HRESULT unacquireJoystick();
		HRESULT unacquireKeyboard();
		HRESULT unacquireMouse();
		HRESULT uninitialize();
		bool	setRect(int left, int top, int right, int bottom);
		bool	releaseRect();
		
		long	m_dwMouseXPos;
		long	m_dwMouseYPos;
		long	m_dwJoyXPos;
		long	m_dwJoyYPos;
		bool	m_bMouseButtonPressed[3];
		char	m_keyboardData[256];
		bool	m_bJoyMoved[4];			
		bool	m_bJoyButtonPressed[4];
};


#endif


class	XInput;


/////////////////////////////////////////////////////////////////////////////////////
// Ende der Datei:	XInput.h
/////////////////////////////////////////////////////////////////////////////////////