/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		global.h
/////////////////////////////////////////////////////////////////////////////////////
// Autor:			Christian Roesch
//
// Erstelldatum:	24.07.2001
// letzte nderung:	27.09.2001
/////////////////////////////////////////////////////////////////////////////////////
// Info:	globale Object und Funktionsdefinitionen				
/////////////////////////////////////////////////////////////////////////////////////

#ifndef _global_H
#define _global_H



// includes
#include "Xgamesdk\XApplication.h"
#include "Xgamesdk\XDisplay.h"
#include "Xgamesdk\XTimer.h"
#include "Xgamesdk\XInput.h"
#include "Xgamesdk\XFModHelper.h"
#include "PPart.h"
#include "PPDummy.h"
#include "Config.h"
#include "HighScore.h"
#include "TileSetData.h"



//Number of Players
extern const int iNumberOfPlayers;

//Number of SinglePlayer Level
extern int iNumberOfSinglePlayLevel;

//Number of DeathMatch Level
extern int iNumberOfDeathMatchLevel;

//Number of Challenge Level
extern int iNumberOfChallengeLevel;

//Number of CTF Level
extern int iNumberOfCTFLevel;

//Number of EatEmAll Level
extern int iNumberOfEatEmAllLevel;

//to switch between states from everywhere
extern void setProgramState(State	stateNew);


//global Application Object (does WinApi stuff)
extern XApplication	g_xaApplication;

//global DDraw Display Object
extern XDisplay		g_xdDisplay;

//global Timer Object
extern XTimer		g_xtTimer;

//global Input Object
extern XInput		g_xiInput;

//helper for FMod
extern XFModHelper	g_xfmodHelper;

//indicates if application is active
extern bool			g_bIsActive;

//Pointer to actual programm part
extern PPart*		g_pPPartActual;

//globale Config-Klasse
extern Config g_configData;

//globale HighScore-Klasse
extern HighScore g_hsData;

//Klasse mit den TileSetDaten
extern TileSetData g_TileSetData;


#endif // _global_H


enum State;

/////////////////////////////////////////////////////////////////////////////////////
// Dateiname:		global.h
/////////////////////////////////////////////////////////////////////////////////////
